/****** ORIGINAL MAIN.C FILE ******/

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "minisoc_hardware.h"
#include "ints.h"
#include "ps2.h"
#include "keyboard.h"
#include "textbuffer.h"
#include "spi.h"
#include "fat.h"
#include "dhry.h"
//#include "ubasic.h"

short *FrameBuffer;
short *MusicBuffer;
short *SoundEffBuffer;

short *musicptr;
short *effectptr;

char frame_skip;

unsigned char DAC_enabled;

extern short pen;
extern void DrawIteration();

unsigned char DAC34_enabled;

static short framecount=0;
static short frame_countvalue=0;
static short noise_count=0;
static short LED_count=0;
static short LED_reg=8;
short MouseX=0,MouseY=0,MouseButtons=0;
short mousetimeout=0;

int microseconds=0;
static int music_samples=0;
static int effect_samples=0;

static int max_samples=0;

void vblank_int()
{
	int yoff;
	
	if(++frame_skip > 3)
	{
		frame_skip = 0;
		framecount=framecount+frame_countvalue;
		yoff = framecount;
	}
	
	microseconds+=16667;	// Assumes 60Hz video mode.	
	if(framecount>3839)
		framecount=0;
//	if(framecount>=480)
	//	yoff=959-framecount;
//	else
		yoff=framecount;
	HW_VGA_L(FRAMEBUFFERPTR)=(unsigned long)(&FrameBuffer[yoff*640]);

	while(PS2MouseBytesReady()>=3)	// FIXME - institute some kind of timeout here to re-sync if sync lost.
	{
		short nx;
		short w1,w2,w3;
		w1=PS2MouseRead();
		w2=PS2MouseRead();
		w3=PS2MouseRead();
		MouseButtons=w1;
//		printf("%02x %02x %02x\n",w1,w2,w3);
		if(w1 & (1<<5))
			w3|=0xff00;
		if(w1 & (1<<4))
			w2|=0xff00;
//			HW_PER(PER_HEX)=(w2<<8)|(w3 & 255);

		nx=MouseX+w2;
		if(nx<0)
			nx=1;
		if(nx>639)
			nx=639;
		MouseX=nx;

		nx=MouseY-w3;
		if(nx<0)
			nx=0;
		if(nx>463)
			nx=463;
		MouseY=nx;
	}
	
	if(music_samples > max_samples) 
	{
		musicptr=MusicBuffer;	
		music_samples = 0;
	}
	
	if (DAC_enabled == 0) goto skip_music;  // Is our Music DAC enabled?
	repeat_fill:
	if (HW_PER(PER_AUDIO_CH1) == 1) // Skip Music DAC buffer load if full
	{
		goto skip_music;
	}
	else
	{
		HW_PER(PER_AUDIO_CH1) = *(musicptr++);
		HW_PER(PER_AUDIO_CH1) = *(musicptr++);
		HW_PER(PER_AUDIO_CH1) = *(musicptr++);
		HW_PER(PER_AUDIO_CH1) = *(musicptr++);
		HW_PER(PER_AUDIO_CH1) = *(musicptr++);
		HW_PER(PER_AUDIO_CH1) = *(musicptr++);
		HW_PER(PER_AUDIO_CH1) = *(musicptr++);
		HW_PER(PER_AUDIO_CH1) = *(musicptr++);	
		HW_PER(PER_AUDIO_CH1) = *(musicptr++);
		HW_PER(PER_AUDIO_CH1) = *(musicptr++);
		HW_PER(PER_AUDIO_CH1) = *(musicptr++);
		HW_PER(PER_AUDIO_CH1) = *(musicptr++);
		HW_PER(PER_AUDIO_CH1) = *(musicptr++);
		HW_PER(PER_AUDIO_CH1) = *(musicptr++);
		HW_PER(PER_AUDIO_CH1) = *(musicptr++);
		HW_PER(PER_AUDIO_CH1) = *(musicptr++);	
		music_samples += 16;
	
		goto repeat_fill;
	}	
	skip_music:

	
	
	HW_VGA(SP0XPOS)=MouseX;
	HW_VGA(SP0YPOS)=MouseY;
	
	
		if((MouseButtons&2) && noise_count > 10)
		{
			puts("Music Off!\n");
			DAC_enabled = 0;
			noise_count = 0;
		}
		
		if((MouseButtons&4) && noise_count > 10)
		{
			puts("Music On!\n");
			DAC_enabled = 1;
			noise_count = 0;
		}		
	
		if((MouseButtons&1) && noise_count > 10)
		{
			printf ("Mouse X/Y = %d/%d\n", (int)MouseX, (int)MouseY);
			noise_count = 0;
		}

	
		noise_count++;
		LED_count++;
		if(LED_count > 30)
		{
			LED_reg = LED_reg >> 1;
			if(LED_reg == 0) LED_reg = 8;
			HW_PER(PER_HEX)=~LED_reg;
			LED_count = 0;
		}
	
	if(PS2KeyboardBytesReady())
		HandlePS2RawCodes();
}

void timer_int()
{
	if(HW_PER(PER_TIMER_CONTROL) & (1<<PER_TIMER_TR5))
		mousetimeout=1;
//	puts("Timer int received\n");
}


void SetTimeout(int delay)
{
	HW_PER(PER_TIMER_CONTROL)=(1<<PER_TIMER_EN5);
	HW_PER(PER_TIMER_DIV5)=delay;
}


void AddMemory()
{
	size_t low;
	size_t size;
	low=(size_t)&heap_low;
	low+=7;
	low&=0xfffffff8; // Align to SDRAM burst boundary
	size=((char*)&heap_top)-low;
	printf("Heap_low: %lx, heap_size: %lx\n",low,size);
	malloc_add((void*)low,size);
}

void Do_sound_effect()
{
	if((framecount == 0) && (DAC34_enabled == 0))	
	{
		effect_samples = 0;
		effectptr=SoundEffBuffer;
		DAC34_enabled = 1;
	}

	if (DAC34_enabled == 0) goto skip_effect;  // Is our Music DAC enabled?	
	repeat_fill2:
	if (HW_PER(PER_AUDIO_CH2) == 1) // Skip Music DAC buffer load if full
	{
		goto skip_effect;
	}
	else
	{
		HW_PER(PER_AUDIO_CH2) = *(effectptr++);
		HW_PER(PER_AUDIO_CH2) = *(effectptr++);
		HW_PER(PER_AUDIO_CH2) = *(effectptr++);
		HW_PER(PER_AUDIO_CH2) = *(effectptr++);
		HW_PER(PER_AUDIO_CH2) = *(effectptr++);
		HW_PER(PER_AUDIO_CH2) = *(effectptr++);
		HW_PER(PER_AUDIO_CH2) = *(effectptr++);
		HW_PER(PER_AUDIO_CH2) = *(effectptr++);	
		HW_PER(PER_AUDIO_CH2) = *(effectptr++);
		HW_PER(PER_AUDIO_CH2) = *(effectptr++);
		HW_PER(PER_AUDIO_CH2) = *(effectptr++);
		HW_PER(PER_AUDIO_CH2) = *(effectptr++);
		HW_PER(PER_AUDIO_CH2) = *(effectptr++);
		HW_PER(PER_AUDIO_CH2) = *(effectptr++);
		HW_PER(PER_AUDIO_CH2) = *(effectptr++);
		HW_PER(PER_AUDIO_CH2) = *(effectptr++);	
		effect_samples += 16;
		goto repeat_fill2;
	}	
	skip_effect:
	if(effect_samples > 11000) DAC34_enabled = 0;
}


extern DIRENTRY DirEntry[MAXDIRENTRIES];
extern unsigned char sort_table[MAXDIRENTRIES];
extern unsigned char nDirEntries;
extern unsigned char iSelectedEntry;
extern unsigned long iCurrentDirectory;
extern char DirEntryLFN[MAXDIRENTRIES][261];
char DirEntryInfo[MAXDIRENTRIES][5]; // disk number info of dir entries
char DiskInfo[5]; // disk number info of selected entry

// print directory contents
void PrintDirectory(void)
{
	unsigned char i;
	unsigned char k;
	unsigned long len;
	char *lfn;
	char *info;
	char *p;
	unsigned char j;

	for (i = 0; i < 8; i++)
	{
		k = sort_table[i]; // ordered index in storage buffer
		lfn = DirEntryLFN[k]; // long file name pointer
		if (lfn[0]) // item has long name
		{
			puts(lfn);
		}
		else  // no LFN
		{
			puts(&DirEntry[k].Name);
		}

		if (DirEntry[k].Attributes & ATTR_DIRECTORY) // mark directory with suffix
			puts("<DIR>\n");
		else
			puts("\n");
	}
}


void c_entry()
{
	unsigned short FUUUCK;
	unsigned short i;
	fileTYPE file;
	unsigned char *fbptr;
	
	DAC_enabled = 0;


	ClearTextBuffer();


	AddMemory();

	// *** Flush Music Buffer ***
		for (i = 0; i < 1024; i++)
		{	
			HW_PER(PER_AUDIO_CH1) = 32639;
		}

	// *** Flush Sound effect Buffer ***
		for (i = 0; i < 1024; i++)
		{	
			HW_PER(PER_AUDIO_CH2) = 32639;
		}

	PS2Init();
	SetSprite();



	
	FrameBuffer=(short *)malloc(sizeof(short)*640*3840);
	SoundEffBuffer=(short *)malloc(sizeof(short)*12200*1);
	HW_VGA_L(FRAMEBUFFERPTR)=FrameBuffer;

	MusicBuffer=(short *)malloc(sizeof(short)*24400*65);
	
	memset(FrameBuffer,0,sizeof(short)*640*3840);
	memset(MusicBuffer,0,sizeof(short)*24400*65);
	memset(SoundEffBuffer,0,sizeof(short)*12200*1);	
	
	max_samples = (24400*65)-1000;
	
	EnableInterrupts();

	while(PS2MouseRead()>-1)
		; // Drain the buffer;
	PS2MouseWrite(0xf4);

	SetIntHandler(PER_INT_TIMER,&timer_int);
	SetTimeout(10000);
	while(PS2MouseRead()!=0xfa && mousetimeout==0)
		; // Read the acknowledge byte

	if(mousetimeout)
		puts("Mouse timed out\n");




	// Don't set the VBlank int handler until the mouse has been initialised.
	SetIntHandler(VGA_INT_VBLANK,&vblank_int);

	puts("Initialising SD card\n");
	spi_init();

	FindDrive();



	ChangeDirectory(DIRECTORY_ROOT);
	ScanDirectory(SCAN_INIT, "*", 0);
	PrintDirectory();

	/* Load our raw graphics bitmap! */
	fbptr=FrameBuffer;
	if(FileOpen(&file,"WALL    IMG"))
	{
//		printf("Got file...\n");
		short imgsize=file.size/512;
		int c=0;
//		puts("Reading block");
		while(c<=((640*3840*2-1)/512) && c<imgsize)
		{
//			putchar('.');
			FileRead(&file, fbptr);
			c+=1;
			FileNextSector(&file);
			fbptr+=512;
		}
		putchar('\n');
	}
	else
		puts("Couldn't load wall.img\n");
	
	
	/* Load our music track! */
	fbptr=MusicBuffer;
	if(FileOpen(&file,"MUSIC   RAW"))
	{
//		printf("Got file...\n");
		short imgsize=file.size/512;
		int c=0;
//		puts("Reading block");
		while(c<=((24400*65*2-1)/512) && c<imgsize)
		{
//			putchar('.');
			FileRead(&file, fbptr);
			c+=1;
			FileNextSector(&file);
			fbptr+=512;
		}
		putchar('\n');
	}
	else
		puts("Couldn't load music.raw\n");

		
	/* Load our "boing" sound effect! */
	fbptr=SoundEffBuffer;
	if(FileOpen(&file,"BOING   RAW"))
	{
//		printf("Got file...\n");
		short imgsize=file.size/512;
		int c=0;
//		puts("Reading block");
		while(c<=((12200*1*2-1)/512) && c<imgsize)
		{
//			putchar('.');
			FileRead(&file, fbptr);
			c+=1;
			FileNextSector(&file);
			fbptr+=512;
		}
		putchar('\n');
	}
	else
		puts("Couldn't load boing.raw\n");		
		
	
	musicptr=MusicBuffer;	
	effectptr=SoundEffBuffer;
	DAC_enabled = 1;
	DAC34_enabled = 0;
	frame_countvalue=240;
	ClearTextBuffer();
	
	puts("FleaFPGA Juggler Demo\n");
	puts("by Valentin Angelovski\n");
	
	while(1)
	{
		/*HW_PER(PER_HEX)=MouseButtons;
		if(MouseButtons&1)
			pen+=0x400;
		if(MouseButtons&2)
			pen-=0x400;*/
//		DrawIteration();

		Do_sound_effect();
		//Dhrystone();




//		++counter;
//		printf("Hello world! Iteration %d\n",counter);
	}
}


